Docker-in-Docker (DinD) capabilities of public runners deactivated. More info

Dockerfile 4.5 KB
Newer Older
Marco Leoni's avatar
Marco Leoni committed
1 2
FROM jupyter/tensorflow-notebook
# FROM jupyter/scipy-notebook # just commented out
3
#FROM jupyter/minimal-notebook
Marco Leoni's avatar
Marco Leoni committed
4 5

USER root
Nicolas M. Thiéry's avatar
Nicolas M. Thiéry committed
6 7

# Install system utilities with apt
Nicolas Thiéry's avatar
Nicolas Thiéry committed
8
# Also install ocaml and dependency rlwrap for L2 CS course by Kim Nguyen
Marco Leoni's avatar
Marco Leoni committed
9
RUN apt-get update && \
10
    apt-get install -y --no-install-recommends \
11
        openssh-client rsync unison less tree curl gdb libopenjp2-7 \
12
        ocaml rlwrap dune js-of-ocaml libjs-of-ocaml \
13
        net-tools traceroute iputils-ping \
Nicolas M. Thiéry's avatar
Nicolas M. Thiéry committed
14
        time \
15
        dbus-x11 xfce4 xfce4-panel xfce4-session xfce4-settings xorg xubuntu-icon-theme && \
Marco Leoni's avatar
Marco Leoni committed
16 17 18
    apt-get clean && \
    rm -rf /var/lib/apt/lists/*

19 20
# Setup default prompt
RUN echo 'export PS1=`echo $JUPYTERHUB_USER| sed s/-at-.*//`"@jupyterhub:\w\$ "' > /etc/profile.d/02-prompt.sh
21 22
# Hack to override the setting of PS1 in the users's bashrc
RUN ln -s /etc/profile.d/02-prompt.sh /etc/bash_completion
23 24
# Enable extended file globs in bash
RUN echo 'shopt -s extglob' > /etc/profile.d/03-extglob.sh
25 26 27 28
# With the current jupyter emage, conda is activated via
# /etc/skels/.bashrc; older accounts may not beneficiate from it.
# Force activation for everyone.
RUN echo 'eval "$(command conda shell.bash hook 2> /dev/null)"' > /etc/profile.d/04-conda-activate.sh
29 30 31 32 33
# Limit to 10M the size of core dumps
# Limit to 100M the size of files generated from commands in the shell
RUN echo 'ulimit -c 10000; ulimit -f 100000' > /etc/profile.d/05-ulimit.sh
RUN echo 'ulimit -c 10000; ulimit -f 100000' > /etc/profile.d/05-ulimit.sh
# Force core files to be named 'core'
34
RUN (echo 'kernel.core_uses_pid = 0'; echo 'kernel.core_pattern = core') > /etc/sysctl.d/60-local.conf
Marco Leoni's avatar
Marco Leoni committed
35

Nicolas M. Thiéry's avatar
Nicolas M. Thiéry committed
36 37
USER $NB_UID

38 39 40
# Install mamba
RUN conda install mamba -c conda-forge

41
# Install the base software stack
42
# RUN conda update  -n base -c conda-forge --update-all
43
COPY environment.yml .
44
RUN mamba env update -n base -f environment.yml && rm environment.yml
45

46 47
# Workaround: pip installed nbgrader-dev requires pyyaml 5.4
# but pip refuses by default to upgrade conda's pyyaml 5.3
Nicolas M. Thiéry's avatar
Nicolas M. Thiéry committed
48
RUN pip3 install --ignore-installed PyYAML
49

50 51 52 53
# The repo for the course "Introduction à la science des données"
# is outdated and clashes with other courses (nbgrader configuration).
# Disabled
#  https://github.com/madclam/info113/                    \
54

55
# Install the software stack for each of the following repositories
Marco Leoni's avatar
Marco Leoni committed
56
RUN for REPO in                                                \
57
        https://gitlab.u-psud.fr/nicolas.thiery/scripts.git           \
58
        https://gitlab.u-psud.fr/Info111/ComputerLab.git       \
Nicolas M. Thiéry's avatar
Nicolas M. Thiéry committed
59
        https://gitlab.u-psud.fr/Info122/Info122.git           \
60
        https://gitlab.u-psud.fr/M1-ISD/AlgorithmiqueAvancee/Instructors \
Nicolas M. Thiéry's avatar
Nicolas M. Thiéry committed
61
        https://gitlab.u-psud.fr/nicolas.thiery/ter-jupyter    \
Marco Leoni's avatar
Marco Leoni committed
62 63 64 65 66 67
        ; do                                                   \
        echo =================================================;\
        echo Installing software stack for:                   ;\
        echo   $REPO                                          ;\
        echo =================================================;\
        git clone $REPO repo                        &&         \
68
        (cd repo; test -d binder && cd binder; mamba env update -n base -f environment.yml) &&         \
Marco Leoni's avatar
Marco Leoni committed
69 70 71 72
        rm -rf repo                                 ||         \
        break 0;                                               \
    done

73 74
## Install SageMath, for now in a different environment
#RUN mamba create --yes -n sage sage=9.1
75

76 77 78
# Enable the Visual Studio proxy extension in notebook and lab
# Taken from https://github.com/betatim/vscode-binder/blob/master/postBuild
RUN jupyter serverextension enable --py jupyter_server_proxy
Nicolas M. Thiéry's avatar
Nicolas M. Thiéry committed
79
RUN jupyter labextension install @jupyterlab/server-proxy
80
#RUN code-server --install-extension ms-python.python
81

82
# Install unpackaged jupyterlab extensions
83 84 85
# run_all_buttons is currently incompatible with latest JupyterLab 3;
# ignoring error message for now
RUN jupyter labextension install @wallneradam/run_all_buttons; exit 0
86

Nicolas M. Thiéry's avatar
Nicolas M. Thiéry committed
87 88 89 90 91
# # Force jupyterlab rebuild (see https://github.com/jupyterlab/jupyterlab/issues/4930)
# RUN jupyter lab build && \
#     jupyter lab clean && \
#     jlpm cache clean && \
#     npm cache clean --force
92 93 94 95

# Force nbgrader extension reinstallation to ensure 0.7.dev
RUN jupyter nbextension install --sys-prefix --py nbgrader --overwrite && \
    jupyter nbextension enable --sys-prefix --py nbgrader && \
96 97 98 99
    jupyter serverextension enable --sys-prefix --py nbgrader && \
    jupyter lab clean && \
    jlpm cache clean && \
    npm cache clean --force && \
100
    pip cache purge; exit 0